#!/usr/bin/env python3

import sys
import time
from binascii import hexlify
from binascii import unhexlify
from Crypto.Hash import SHA256
from Crypto.Cipher import AES


## You know, it would only be half the fun without those. :)
TERM_RED = '\033[91m'
TERM_GREEN = '\033[92m'
TERM_BLUE = '\033[94m'
TERM_BLINK = '\033[5m'
TERM_RESET = '\033[0m'

ROUNDS    = 1000000 ## no bruteforce plz :>
IV        = "dc36b2f428e85533ae11c7630f6bd47d"
FLAG_HASH = "b768dab2b4ac647cae503a6c81773308f55cebb8763e89505ed32771118eaec6"
FLAG      = "94583cfb688694d41b74aaa609d5cc66364e98fafd0d4dc313dc25a1b69175d6eac87ec3dc38159363f4b22f6279f6bc"

print("So here you are", end = "", flush = True)
for c in " . . . ":
    time.sleep(.5)
    print(c, end = "", flush = True)
print(" {}tired{}".format(TERM_RED, TERM_RESET), end = "", flush = True)
time.sleep(1.5)
print(", {}exhausted{}".format(TERM_BLUE, TERM_RESET), end = "", flush = True)
time.sleep(1.5)
print(", desiring to receive a ", end = "", flush = True)
time.sleep(.75)
print("{}flag{}?".format(TERM_GREEN, TERM_RESET))
time.sleep(2.5)

print("Fine. Then please tell me the secret key (64 hex digits).")
print("> ", end = "", flush = True)
key = input()

if len(key) != 64:
    print("Nope.")
    sys.exit(-1)

try:
    key = unhexlify(key)
except:
    print("Nope.")
    sys.exit(-1)

print("Seems legit. Let me check this key for you ...")

for _ in range(ROUNDS):
    key = SHA256.SHA256Hash(key).digest()

aes = AES.new(key, AES.MODE_CBC, unhexlify(IV))
dec = aes.decrypt(unhexlify(FLAG)).strip(b"\x00")

if SHA256.SHA256Hash(dec).hexdigest() != FLAG_HASH:
    print("Nope.")
    sys.exit(-1)
else:
    print("Correct.")
    time.sleep(0.5)
    print("Here is your flag: {}{}{}".format(
        TERM_GREEN + TERM_BLINK, dec.decode(), TERM_RESET))
